DISK3  ; DISK3/ASM
 SELECT0	LD	A,(DRIV)
 	AND	0FH
 	LD	(DRIV),A
 	BIT	7,(IY)
 	JR	Z,FIXDEN
 	BIT	6,(IY)
 	JR	Z,GOTDEN
 	BIT	5,(IY)
 	JR	NZ,GOTDEN
 	LD	A,(IY+15)
 	OR	A
 	JR	Z,FIXDEN
 GOTDEN	LD	A,(DRIV)
 	SET	7,A
 	LD	(DRIV),A
 FIXDEN	LD	A,(IY+15)
 	CP	16H
 	JR	C,SELECT
 	LD	A,(DRIV)
 	SET	5,A
 	LD	(DRIV),A
 SELECT	IN	A,(0F0H)
 	AND	80H
 	LD	A,1		;get drive bit
 DRIV	EQU	$-1
 	OUT	(0F4H),A
 	RET	Z
 	PUSH	BC
 	LD	BC,0
 	CALL	60H
 	POP	BC
 	IN	A,(0F0H)
 	AND	80H
 	RET
 SEEK	LD	A,D
 	LD	(IY+15),A
 	CALL	SELECT0
 	JP	NZ,RESET
 	CALL	GETTRK	;get track from table
 	OUT	(0F1H),A
 	JR	NZ,SEEK1	;continue if not track 0
 	CALL	RESTORE		;restore to track 0
 	JP	NZ,RESET
 SEEK1	LD	A,D
 	OUT	(0F3H),A
 	LD	A,E
 	OUT	(0F2H),A
 	LD	A,18H		;seek command
 	CALL	MOVE		;move the head
 	JP	NZ,RESET
 	IN	A,(0F1H)
 PUTTRK	PUSH	HL		;save this
 	LD	HL,CTRACK	;current track table
 	PUSH	AF
 	LD	A,0		;get binary drive
 DRIVE	EQU	$-1
 	ADD	A,L		;point to drive
 	LD	L,A
 	POP	AF		;get track back
 	LD	(HL),A		;put in table
 	POP	HL		;restore HL
 	XOR	A
 	RET		;Z flag set
 RESTORE	LD	A,8
 	CALL	MOVE
 	JP	NZ,RESET
 	IN	A,(0F0H)
 	CPL
 	AND	4
 	RET
 MOVE	AND	0FCH
 	OR	(IY+2)
 	PUSH	AF
 	CALL	SELECT
 	POP	AF
 	OUT	(0F0H),A
 	CALL	DSKSLO
 MOVEWT	CALL	SELECT		;keep drive on
 	RET	NZ
 	IN	A,(0F0H)
 	BIT	0,A		;still busy?
 	JR	NZ,MOVEWT	;wait till done
 	AND	18H
 	RET			;Z flag set if OK
 STEPIN	CALL	SELECT
 	RET	NZ
 	LD	A,58H
 	JP	MOVE
 FORMIT	CALL	BUILDTRK
 	CALL	SELECT0
 	RET	NZ
 TRYWRTG	LD	A,5
 	LD	(IY+17),A
 TRYGOW	CALL	W0
 	AND	0FCH
 	RET	Z
 	EX	AF,AF'
 ;	CALL	RESET
 	DEC	(IY+17)
 	JR	NZ,TRYGOW
 	EX	AF,AF'
 	RET
 DSKSLO	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	NOP
 	RET
 R1	CALL	SEEK
 	RET	NZ		;bad already
 	CALL	SETNMI
 	LD	A,80H
 	OUT	(0F0H),A
 	CALL	DSKSLO
 RX1	IN	A,(0F0H)
 	AND	E
 	JR	Z,RX1
 	INI
 	LD	A,D
 RX2	OUT	(0F4H),A
 	INI
 	JR	NZ,RX2
 	LD	HL,0
 	JR	RX2
 W1	CALL	SEEK
 	RET	NZ
 	IN	A,(0F0H)
 	AND	40H
 	RET	NZ
 	CALL	SETNMI
 	LD	A,(IY+18)
 	OUT	(0F0H),A
 	CALL	DSKSLO
 WX1	IN	A,(0F0H)
 	AND	E
 	JR	Z,WX1
 	OUTI
 	LD	B,60H
 	DJNZ	$
 	LD	A,D
 WX2	OUT	(0F4H),A
 	OUTI
 	JR	WX2
 ORDNEW	PUSH	BC
 	PUSH	DE
 	PUSH	HL
 	EX	DE,HL
 	LD	B,3
 	DEC	C
 	BIT	7,(IY)
 	JR	Z,ORDNEW1
 	LD	B,4
 ORDNEW1	PUSH	BC
 	LD	A,(HL)
 	PUSH	HL
 	INC	HL
 ORDNEW2	LD	E,(HL)
 	LD	(HL),A
 	LD	A,E
 	INC	HL
 	DEC	C
 	JR	NZ,ORDNEW2
 	POP	HL
 	LD	(HL),A
 	POP	BC
 	DJNZ	ORDNEW1
 	POP	HL
 	POP	DE
 	POP	BC
 	RET
 BUILDTRK	BIT	7,(IY)
 	LD	HL,ORDER
 	JR	Z,GOTORD
 	LD	HL,DORDER
 	BIT	6,(IY)
 	JR	Z,GOTORD
 	LD	HL,DORDER2
 	BIT	5,(IY)
 	JR	NZ,GOTORD
 	LD	A,(IY+15)
 	OR	A
 	JR	NZ,GOTORD
 	LD	HL,ORDER
 GOTORD	LD	C,(HL)
 	INC	HL
 	LD	E,(HL)
 	INC	HL
 	LD	D,(HL)
 	INC	HL
 	CALL	ORDNEW
 	PUSH	DE
 	LD	DE,BUFFER
 	EX	DE,HL
 	CALL	MOVEIN
 	LD	(DESVE),DE
 SECLP	CALL	MOVEIN
 	CALL	MOVEIN
 	LD	(HL),0FEH
 	INC	HL
 	LD	A,(IY+15)
 	LD	(HL),A
 	INC	HL
 	LD	(HL),0
 	INC	HL
 	EX	(SP),HL
 	LD	A,(HL)
 	INC	HL
 	EX	(SP),HL
 	LD	(HL),A
 	INC	HL
 	LD	(HL),1
 	INC	HL
 	LD	(HL),0F7H
 	INC	HL
 	CALL	MOVEIN
 	CALL	MOVEIN
 	CALL	MOVEIN
 	LD	(HL),0FBH
 	INC	HL
 	CALL	FILLDATA
 	LD	(HL),0F7H
 	INC	HL
 	CALL	MOVEIN
 	LD	DE,0
 DESVE	EQU	$-2
 	DEC	C
 	JR	NZ,SECLP
 	INC	SP
 	INC	SP
 	DEC	DE
 	LD	A,(DE)
 	JP	FILL
 ORDER	DB	10
 	DW	ORDERS
 	DB	1FH,0FFH
 	DB	3,0
 	DB	3,0
 	DB	0BH,0FFH
 	DB	3,0
 	DB	3,0
 	DB	0BH,0FFH
 DORDER	DB	18
 	DW	ORDERD
 	DB	3EH,4EH
 	DB	0CH,0
 	DB	3,0F5H
 	DB	16H,4EH
 	DB	0CH,0
 	DB	3,0F5H
 	DB	16H,4EH
 DORDER2	DB	18
 	DW	ORDERD2
 	DB	3EH,4EH
 	DB	0CH,0
 	DB	3,0F5H
 	DB	16H,4EH
 	DB	0CH,0
 	DB	3,0F5H
 	DB	16H,4EH
 ORDERS	DB	0,5,1,6,2,7,3,8,4,9
 ORDERD	DB	1,4,7,0AH,0DH,10H,2,5,8,0BH
 	DB	0EH,11H,3,6,9,0CH,0FH,12H
 ORDERD2	DB	0,6,12,1,7,13,2,8,14
 	DB	3,9,15,4,10,16,5,11,17
 MOVEIN	LD	A,(DE)
 	INC	DE
 	LD	B,A
 	LD	A,(DE)
 	INC	DE
 FILL	LD	(HL),A
 	INC	HL
 	DJNZ	FILL
 	RET
 READ	LD	A,5
 	LD	(IY+17),A
 READGO	PUSH	BC
 	CALL	R1
 	POP	HL
 	AND	9CH
 	RET	Z
 	EX	AF,AF'
 ;	CALL	RESET
 	LD	B,H
 	LD	C,L
 	DEC	(IY+17)
 	JR	NZ,READGO
 	EX	AF,AF'
 	RET
 WRITE	LD	A,5
 	LD	(IY+17),A
 WRGO	PUSH	BC
 	CALL	W1
 	POP	HL
 	AND	0FCH
 	RET	Z
 	EX	AF,AF'
 ;	CALL	RESET
 	LD	B,H
 	LD	C,L
 	DEC	(IY+17)
 	JR	NZ,WRGO
 	EX	AF,AF'
 	RET
 W0	CALL	SELECT
 	RET	NZ
 	LD	BC,BUFFER
 	CALL	SETNMI
 	LD	B,3
 	LD	A,0F0H
 	OUT	(0F0H),A
 	CALL	DSKSLO
 W0X1	LD	A,D
 	OUT	(0F4H),A
 	IN	A,(0F0H)
 	AND	B
 	JP	PO,W0X1
 	OUTI
 W0X2	LD	A,D
 	OUT	(0F4H),A
 	IN	A,(0F0H)
 	AND	E
 	JR	Z,W0X2
 	OUTI
 	LD	A,D
 W0X3	OUT	(0F4H),A
 	OUTI
 	JP	W0X3
 GETTRK	PUSH	HL
 	LD	HL,CTRACK
 	LD	A,(DRIVE)
 	ADD	A,L
 	LD	L,A
 	LD	A,(HL)
 	POP	HL
 	OR	A
 	RET
 FILLDATA	PUSH	DE
 	LD	DE,0E5E5H
 	BIT	7,(IY)
 	JR	Z,FILLGO
 	LD	DE,6DB6H
 	BIT	6,(IY)
 	JR	Z,FILLGO
 	BIT	5,(IY)
 	JR	NZ,FILLGO
 	LD	A,(IY+15)
 	OR	A
 	JR	NZ,FILLGO
 	LD	DE,0E5E5H
 FILLGO	LD	B,128
 	LD	(HL),D
 	INC	HL
 	LD	(HL),E
 	INC	HL
 	DJNZ	FILLGO+2
 	POP	DE
 	RET
 STAT	CALL	SELECT
 	RET	NZ
 	LD	BC,200H
 STAT1	DEC	BC
 	LD	A,B
 	OR	C
 	JR	Z,STAT0
 	IN	A,(0F0H)
 	AND	2
 	JR	NZ,STAT1
 	LD	BC,4000H
 STAT2	DEC	BC
 	LD	A,B
 	OR	C
 	JR	Z,STAT0
 	IN	A,(0F0H)
 	AND	2
 	JR	Z,STAT2
 	LD	BC,200H
 STAT3	DEC	BC
 	LD	A,B
 	OR	C
 	JR	Z,STAT0
 	IN	A,(0F0H)
 	AND	2
 	JR	NZ,STAT3
 	XOR	A
 	RET
 STAT0	OR	1
 RESET	PUSH	AF
 	LD	A,0D0H
 	OUT	(0F0H),A
 	POP	AF
 	RET
 NEXSEC	BIT	7,(IY)
 	JR	Z,NEXSNG
 	BIT	6,(IY)
 	JR	Z,NEXDBL2
 	BIT	5,(IY)
 	JR	NZ,NEXDBL
 	LD	A,(IY+15)
 	OR	A
 	JR	NZ,NEXDBL
 NEXSNG	INC	E
 	LD	A,E
 	SUB	10
 NEXSNGX	RET	NZ
 	LD	E,A
 	INC	D
 	RET
 NEXDBL	INC	E
 	LD	A,E
 	SUB	18
 	JR	NEXSNGX
 NEXDBL2	INC	E
 	LD	A,E
 	SUB	19
 	RET	NZ
 	LD	E,1
 	INC	D
 	RET
 SETNMI	LD	(BUFFSAVE),BC
 	LD	(SECSAVE),DE
 	LD	HL,RETNMI
 	LD	A,0C0H
 	OUT	(0E4H),A
 	DI
 	LD	(404AH),HL
 	LD	H,B
 	LD	L,C
 	LD	A,(DRIV)
 	OUT	(0F4H),A
 	OR	40H
 	LD	D,A
 	LD	E,2
 	LD	BC,0F3H
 	IN	A,(0F0H)
 	RET
 RETNMI	XOR	A
 	OUT	(0E4H),A
 	LD	HL,NMIRET
 	LD	(404AH),HL
 	POP	HL
 	LD	BC,0
 BUFFSAVE	EQU	$-2
 	LD	DE,0
 SECSAVE	EQU	$-2
 	INC	B
 	CALL	DSKSLO
 FDCWT	IN	A,(0F0H)
 ;	BIT	0,A
 ;	JR	NZ,FDCWT
 	LD	(IY+16),A
 	EI
 	JP	RESET
